package com.ruoyi.user.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ruoyi.user.enums.UserThirdType;
import com.ruoyi.user.exception.UserExceptionEnum;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.user.domain.bo.UserThirdIdentityBo;
import com.ruoyi.user.domain.vo.UserThirdIdentityVo;
import com.ruoyi.user.domain.UserThirdIdentity;
import com.ruoyi.user.mapper.UserThirdIdentityMapper;
import com.ruoyi.user.service.IUserThirdIdentityService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 小程序用户在第三方平台中的身份（如果在小程序中的openid）Service业务层处理
 *
 * @author ruoyi
 * @date 2022-03-03
 */
@RequiredArgsConstructor
@Service
public class UserThirdIdentityServiceImpl implements IUserThirdIdentityService {

    private final UserThirdIdentityMapper baseMapper;

    /**
     * 查询小程序用户在第三方平台中的身份（如果在小程序中的openid）
     *
     * @param id 小程序用户在第三方平台中的身份（如果在小程序中的openid）主键
     * @return 小程序用户在第三方平台中的身份（如果在小程序中的openid）
     */
    @Override
    public UserThirdIdentityVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询小程序用户在第三方平台中的身份（如果在小程序中的openid）列表
     *
     * @param bo 小程序用户在第三方平台中的身份（如果在小程序中的openid）
     * @return 小程序用户在第三方平台中的身份（如果在小程序中的openid）
     */
    @Override
    public TableDataInfo<UserThirdIdentityVo> queryPageList(UserThirdIdentityBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<UserThirdIdentity> lqw = buildQueryWrapper(bo);
        Page<UserThirdIdentityVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询小程序用户在第三方平台中的身份（如果在小程序中的openid）列表
     *
     * @param bo 小程序用户在第三方平台中的身份（如果在小程序中的openid）
     * @return 小程序用户在第三方平台中的身份（如果在小程序中的openid）
     */
    @Override
    public List<UserThirdIdentityVo> queryList(UserThirdIdentityBo bo) {
        LambdaQueryWrapper<UserThirdIdentity> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<UserThirdIdentity> buildQueryWrapper(UserThirdIdentityBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<UserThirdIdentity> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getIdentityCode()), UserThirdIdentity::getIdentityCode, bo.getIdentityCode());
        lqw.eq(bo.getThirdType() != null, UserThirdIdentity::getThirdType, bo.getThirdType());
        lqw.eq(bo.getUserId() != null, UserThirdIdentity::getUserId, bo.getUserId());
        return lqw;
    }

    /**
     * 新增小程序用户在第三方平台中的身份（如果在小程序中的openid）
     *
     * @param bo 小程序用户在第三方平台中的身份（如果在小程序中的openid）
     * @return 结果
     */
    @Override
    public Boolean insertByBo(UserThirdIdentityBo bo) {
        UserThirdIdentity add = BeanUtil.toBean(bo, UserThirdIdentity.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改小程序用户在第三方平台中的身份（如果在小程序中的openid）
     *
     * @param bo 小程序用户在第三方平台中的身份（如果在小程序中的openid）
     * @return 结果
     */
    @Override
    public Boolean updateByBo(UserThirdIdentityBo bo) {
        UserThirdIdentity update = BeanUtil.toBean(bo, UserThirdIdentity.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(UserThirdIdentity entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除小程序用户在第三方平台中的身份（如果在小程序中的openid）
     *
     * @param ids 需要删除的小程序用户在第三方平台中的身份（如果在小程序中的openid）主键
     * @return 结果
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }

    @Override
    public UserThirdIdentity loadByUserId(Long userId, Boolean tw) {
        UserThirdIdentity info = baseMapper.selectOne(
            Wrappers.lambdaQuery(UserThirdIdentity.class).eq(UserThirdIdentity::getUserId, userId).last("limit 1"));
        if (tw) {
            if (ObjectUtil.isEmpty(info)) {
                throw new ServiceException(UserExceptionEnum.USER_THIRD_ID_NOT_EXISTS);
            }
        }
        return info;
    }

    @Override
    public UserThirdIdentity loadByUserId(Long userId, UserThirdType thirdType, Boolean tw) {
        UserThirdIdentity info = baseMapper.selectOne(
            Wrappers.lambdaQuery(UserThirdIdentity.class)
                .eq(UserThirdIdentity::getUserId, userId)
                .eq(UserThirdIdentity::getThirdType, thirdType.getCode())
                .last("limit 1"));
        if (tw) {
            if (ObjectUtil.isEmpty(info)) {
                throw new ServiceException(UserExceptionEnum.USER_THIRD_ID_NOT_EXISTS);
            }
        }
        return info;
    }

}
